from tkinter import *
from random import randint

class Game:
    def __init__(self):
        self.ennemis = [] # tableau des envahisseurs

        self.fen = Tk() # fenêtre de jeu
        self.fen.title('Envahisseurs') # titre de la fenêtre
        self.can = Canvas(self.fen, width = 1024, height = 768, background='black') # canevas de dessin
        self.can.pack()

        # création du joueur ( position initiale x = 550 / y = 700 )
        self.joueur = ...

        self.fen.bind("<Key>", self.joueur.move) # gestion des déplacements clavier du joueur

        # instanciation des ennemis ( 3 rangées de 10, de taille 50 x 50 initialement en haut de l'écran)
        ...

        self.run() # lancement du jeu

        self.fen.mainloop() # boucle principale d'évènements Tkinter

    def run(self):
        # EFFACEMENT GENERAL
        self.can.delete('all')

        # AFFICHAGE DU VAISSEAU DU JOUEUR
        ...

        # DEPLACEMENT DES ROCKETS TIREES PAR LE JOUEUR
        for rocket in ... : # parcours du tableau des rockets déja tirées par le joueur
            ... # affichage de la roquette
            ... # déplacement de la roquette
            if (...): # si la roquette a atteint le haut de l'écran
                ... # on la supprime du tableau des roquettes

            for ennemi in ... : # parcours du tableau des ennemis encore en jeu
                if ... : # la rocket touche-t-elle l'ennemi ( destruction mutuelle ) ?
                    ... # si oui, on retire l'ennemi du tableau des ennemis
                    ... # et on retire la roquette du tableau des roquettes

        # DEPLACEMENT DES ENNEMIS, LARGAGE EVENTUEL D'UNE BOMBE, MOUVEMENT DES BOMBES DEJA LACHÉES PAR CHAQUE ENNEMI
        for ennemi in ... : # parcours du tableau des ennemis
            ... # affichage de l'ennemi
            ... # déplacement de l'ennemi
            if randint(1, 500) < 5: # larguage d'une bombe avec une probabilité de 5/500
                x, y = ... # coordonnées de l'ennemi
                ... # largage d'une bombe à partir de la position de l'ennemi ( un peu en dessous...)
            for bombe in ... : # pour chaque bombe déja larguée par l'ennemi
                ... # affichage de la bombe
                ... # déplacement de la bombe
                if (...): # si la bombe a atteint le bas de l'écran
                    ... # on la supprime du tableau des bombes associé à l'ennemi

                if ... : # la bombe touche-t-elle le joueur ?
                    self.fen.destroy() # et on ferme la fenêtre ( ou on affiche GAME OVER )

        self.fen.after(30,self.run) # boucle d'animation


